// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <iostream>
#include "blocker.hh"

PinguAction*
make_Blocker(void)
{
  return new Blocker;
}

Blocker::Blocker()
{
  surface = CL_Res_Surface::load("Pingus/blocker", *resource);
  counter.set_size(4);
  counter.set_type(Counter::loop);
  is_multi_direct = false;
}

void
Blocker::let_move()
{
  if (rel_getpixel(0,-1) == 0) 
    is_finished = true;
}

bool
Blocker::need_catch()
{
  return true;
}


void
Blocker::catch_pingu(PinguData* pingu_data)
{
  if (pingu_data->x_pos > data->x_pos - 16 
      && pingu_data->x_pos < data->x_pos + 16
      && pingu_data->y_pos > data->y_pos - 2
      && pingu_data->y_pos < data->y_pos + 2
      ) 
    {
      if (pingu_data->direction.is_left())
	pingu_data->direction.right();
      else
	pingu_data->direction.left();
    }
}

bool 
Blocker::can_reset() 
{ 
  return false; 
}

/* EOF */
