// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>
#include <assert.h>

#include "background.hh"
#include "globals.hh"

Background::Background(const char* bg_name, CL_ResourceManager* resource)
{
  bg_surface = CL_Res_Surface::load(bg_name, *resource);
  
  if (!bg_surface) {
    cerr << bg_name << ": Could not load file" << endl;
    exit(EXIT_FAILURE);
  }
}

Background::~Background()
{
  delete bg_surface;
}

void
Background::draw()
{
  assert(bg_surface);

  for(int y=0; y <= 426; y += bg_surface->get_height())
    for(int x=0; x < 640; x += bg_surface->get_width())
      bg_surface->put_screen(x, y);
}

void
Background::draw_offset(int x_of, int y_of)
{
  assert(bg_surface);
  // BUG: This function works, but I don't know why =?^)
  //This crashes if the level is restarted
  for(int y=(y_of/2); y < 426; y += bg_surface->get_provider()->get_height())
    for(int x=(x_of/2); x < 640; x += bg_surface->get_provider()->get_width())
      bg_surface->put_screen(x, y);
  
}

void
Background::mark_dirty(int x, int y, int w, int h)
{
  
}

/* EOF */
