// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef BUTTON_HH
#define BUTTON_HH

#include <string>
#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "plf_datatypes.hh"
#include "pingu_action.hh"
#include "gui_obj.hh"
#include "anim_counter.hh"

// The button class manage a simple button for the button_panel. It
// keeps his position, his surfaces and his font.

class Button : public GuiObj
{
private:
  //  static CL_Font*    font;
  MakeAction make_action;
  CL_Surface* button;
  CL_Surface* action;
  //  static CL_Surface* button_p;
  int x_pos;
  int y_pos;
  string name;
  AnimCounter action_c;
public:  
  Button(int x, int y, string str, MakeAction func, CL_ResourceManager*);
  void draw();
  void let_move();
  PinguAction* get_action();
  bool is_pressed();
  void load_data(CL_ResourceManager* res);
};


#endif

/* EOF */
