// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#ifndef PINGU_ACTION_HH
#define PINGU_ACTION_HH

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "anim_counter.hh"
#include "pingu_data.hh"
#include "colmap.hh"
#include "pingumap.hh"
//#include "pingu.hh"

//void change(Direction& dir);

class Pingu; // BUG: Bad style, declare Pingus in an file different than pingu.hh

// This class provides and abstract interface for pingu actions, it is 
// used to inheritate classes which are used to let the pingu walk.
class PinguAction
{
protected:
  CL_Surface* surface;  // The basic surface, the inherit class can
                        // define other surfaces if its need more
  AnimCounter counter;  // Sets the speed and number of frames
  bool is_multi_direct; // This variable is needed in the draw_offset function
  PinguData* data;

  // Static Variables
  static CL_ResourceManager* resource;
  static ColMap* colmap;
public:
  PinguAction();
  ~PinguAction();

  virtual void let_move() = 0;     // The "AI" of the pingu, there is no default AI
  virtual void draw_offset(int x, int y); //
  void set_pingu_data(PinguData&);
  int  rel_getpixel(int x, int y);
  virtual bool can_reset();

  virtual bool need_catch();
  virtual void catch_pingu(PinguData*) {};

  bool is_finished;     // Indicate if the action should be chanceled
                        // at the next possible point

  static void set_colmap(ColMap*);
  static void set_map(PinguMap*);
  static void load_data(CL_ResourceManager*);
};

#endif

/* EOF */
